diff --git a/src/luaapi.c b/src/luaapi.c
index 7f0169489..13453e558 100644
--- a/src/luaapi.c
+++ b/src/luaapi.c
@@ -1069,13 +1069,8 @@ static void checkForceExit(lua_State *lua, lua_Debug *luadebug)
 
 	tic_tick_data* tick = machine->data;
 
-	if(tick->hook)
-	{
-		tick->hook(tick->data);
-
-		if(tick->forceExit)
-			luaL_error(lua, "script execution was interrupted");
-	}
+	if(tick->forceExit && tick->forceExit(tick->data))
+		luaL_error(lua, "script execution was interrupted");
 }
 
 static void initAPI(tic_machine* machine)
diff --git a/src/run.c b/src/run.c
index ca847a430..1c05f7255 100644
--- a/src/run.c
+++ b/src/run.c
@@ -178,14 +178,11 @@ static void preseed()
 #endif
 }
 
-static void poll(void* data)
+static bool forceExit(void* data)
 {
-	Run* run = (Run*)data;
-
 	while(pollEvent());
 
-	if (getStudioMode() != TIC_RUN_MODE)
-		run->tickData.forceExit = true;
+	return getStudioMode() != TIC_RUN_MODE;
 }
 
 void initRun(Run* run, Console* console, tic_mem* tic)
@@ -207,8 +204,7 @@ void initRun(Run* run, Console* console, tic_mem* tic)
 			.data = run,
 			.exit = onExit,
 			.preprocessor = processDoFile,
-			.hook = poll,
-			.forceExit = false,
+			.forceExit = forceExit,
 		},
 	};
 
diff --git a/src/ticapi.h b/src/ticapi.h
index bb3583338..ea61302fc 100644
--- a/src/ticapi.h
+++ b/src/ticapi.h
@@ -45,19 +45,18 @@ typedef struct
 typedef void(*TraceOutput)(void*, const char*, u8 color);
 typedef void(*ErrorOutput)(void*, const char*);
 typedef void(*ExitCallback)(void*);
-typedef void(*HookCallback)(void*);
+typedef bool(*CheckForceExit)(void*);
 
 typedef struct
 {
 	TraceOutput trace;
 	ErrorOutput error;
 	ExitCallback exit;
-	HookCallback hook;
+	CheckForceExit forceExit;
 	
 	u64 (*counter)();
 	u64 (*freq)();
 	u64 start;
-	bool forceExit;
 
 	void (*preprocessor)(void* data, char* dst);
 
